#include <windows.h>
#include "threads.h"

extern HINSTANCE hInst ;
extern MYTHREAD ThreadInfo []  ;		// thread info array

LONG APIENTRY MainWndProc (HWND hWnd, UINT message, UINT wParam,LONG lParam)
{
  
  switch (message)
  {

/*
at creation time, make two threads.  Do this by mimicking the action of
the THREAD-NEW menu item
*/

        case WM_CREATE :
		{
		    
            PostMessage (hWnd, WM_COMMAND, MAKELONG(IDM_THREAD_NEW, 0), 0) ;

           return (0);
		}

/*
item picked from the menu
*/
        case WM_COMMAND:
        {
        	switch (LOWORD(wParam))
            {

/*
user wants a new thread
*/
				case IDM_THREAD_NEW:
				{

					int i ;
/*
try to find free entry in our thread list, 
fail the thread creation with an error message if all are in use
*/

					for (i = 1 ; i < NTHREADS ; i ++)
					{
						if (ThreadInfo[i].hThread == 0)
						{
							break ;
						}
					}

					if (i == NTHREADS)
					{
						MessageBox (NULL, "Agotado espacio de hebras", "Error",
							MB_ICONSTOP) ;
							return 0 ;
					}

/*
Create the thread.  Store its handle and ID in our thread list
*/
					 
          			ThreadInfo [i].hThread = CreateThread (NULL, 0,
                                   (LPTHREAD_START_ROUTINE)ThreadProc,
                                   &ThreadInfo[i].Color, 0,
                                   (LPDWORD)&ThreadInfo[i].Id);      
					return 0 ;
				}
            

/*
User wants to modify a thread.  Pop up the dialog box that does this
*/
				case IDM_THREAD_MODIFY:
				{
					DialogBox (hInst, "ThreadModifyBox", hWnd, ThreadDlgProc) ;
					return 0 ;
				}

/*
shut down the app
*/

				case IDM_THREAD_EXIT:
				{
					SendMessage (hWnd, WM_CLOSE, 0, 0) ;
					return 0 ;
				}

				default:
				{
              		return (0);
				}

            }
		}

        case WM_DESTROY :
		{
		    PostQuitMessage (0);
            return (0);
		}

	}
    return DefWindowProc (hWnd, message, wParam, lParam);
}
